**Free
Ctl-Opt NoMain;
//
// SplitFN
// -------
// Split a filename (no path) into name and extension.
//
// Jesper Wachs, Version 2, August 2018.
//   Converted to Totally Free RPG.
//
// Jesper Wachs, Version 1, August 2016.
//
// The source member are delivered 'as is'.
//
// Neither Jesper Wachs nor anyone else who has been involved in
// the creation, production or delivery of this product shall be
// liable for any direct, indirect, consequential or incidental
// damages (including damages for loss of business profits,
// business interruption, loss of business information, and the
// like) arising out of the use or inability to use such product
// even if Jesper Wachs has been advised of the possibility of
// such damages.
//
// Copymember for exported functions.
// ----------------------------------
/copy qrpglesrc,splitfn_pr

// Exported funtions.
// ------------------
//
// SplitFN
// -------
// Split filename into name and extension.
//
Dcl-Proc SplitFN Export;
Dcl-PI SplitFN;
  iFileName Char(100) Const;
  oName Char(50);
  oExt Char(50);
End-PI;

Dcl-S X Packed(3:0);
Dcl-S Pos Packed(3:0);
Dcl-S Len Packed(3:0);

  // Find last dot in the filename.

  X = *Zeros;
  Pos = *Zeros;
  oName = *Blanks;
  oExt = *Blanks;

  DoU X = *Zeros;

     X = %Scan('.': iFileName: X + 1);
     If X <> *Zeros;
        Pos = X;
     EndIf;

  EndDo;

  // If dot found, then isolate the name and the extension.

  If Pos > *Zeros;

     // Isolate name

     If Pos > 1;
        oName = %SubSt(iFileName: 1: Pos - 1);
     EndIf;

     // Isolate extension.

     Len = %Len(iFileName) - Pos;
     If Len > *Zeros;
        oExt = %SubSt(iFileName: Pos + 1: Len);
     EndIf;

  Else;

     // If there is not dot, we put the filename into Name.

     oName = iFileName;

  EndIf;

  Return;

End-Proc SplitFN;
